<template>
  <b-container class="form-container">
    <b-form @submit.stop.prevent="handleSubmit">
      <b-row>
        <b-col>
          <v-gravatar
            class="avatar-form"
            :email="companyEmail"
            default-img="retro"
          />
          <b-row>
            <b-col class="tags-container">
              <TagsInput
                id="tags"
                v-model="tags"
                name="tags"
                label="TAGS"
                :state="validateState('tags')"
                :editable="editable"
              />
            </b-col>
          </b-row>
        </b-col>

        <b-col cols="6">
          <b-col>
            <b-col>
              <Input
                id="displayName"
                v-model="$v.displayName.$model"
                name="displayName"
                label="Display Name"
                :state="validateState('displayName')"
                invalid-feedback="This is a required field"
                :class="editable ? 'required' : ''"
                :editable="editable"
              />
              <b-row>
                <b-col cols="6">
                  <Input
                    id="firstName"
                    v-model="$v.firstName.$model"
                    name="firstName"
                    label="First Name"
                    :state="validateState('firstName')"
                    invalid-feedback="This is a required field"
                    :class="editable ? 'required' : ''"
                    :editable="editable"
                  />
                  <Input
                    id="lastName"
                    v-model="$v.lastName.$model"
                    name="lastName"
                    label="Last Name"
                    :state="validateState('lastName')"
                    invalid-feedback="This is a required field"
                    :class="editable ? 'required' : ''"
                    :editable="editable"
                  />
                  <Select
                    id="gender"
                    v-model="$v.gender.$model"
                    name="gender"
                    label="Gender"
                    :options="[
                      { value: '', text: 'Choose one' },
                      'Male',
                      'Female'
                    ]"
                    :state="validateState('gender')"
                    invalid-feedback="This is a required field"
                    :class="editable ? 'required' : ''"
                    :editable="editable"
                  />
                  <DatePicker
                    id="startDate"
                    v-model="$v.startDate.$model"
                    name="startDate"
                    label="Start Date"
                    :class="editable ? 'required' : ''"
                    :editable="editable"
                  />
                </b-col>
                <b-col cols="6">
                  <Input
                    id="middleName"
                    v-model="$v.middleName.$model"
                    name="middleName"
                    label="Middle Name"
                    :editable="editable"
                  />
                  <Input
                    id="secondLastName"
                    v-model="$v.secondLastName.$model"
                    name="secondLastName"
                    label="Second Last Name"
                    :editable="editable"
                  />
                </b-col>
              </b-row>
            </b-col>
            <b-col cols="12">
              <label class="group-label">SALARY</label>
              <Radio
                id="salaryType"
                v-model="$v.salaryType.$model"
                name="salaryType"
                type="number"
                :state="validateState('salaryType')"
                invalid-feedback="This is a required field"
                :editable="editable"
                :options="salaryTypes"
              />
              <b-row>
                <b-col cols="6">
                  <Input
                    id="salary"
                    v-model="$v.salary.$model"
                    name="salary"
                    label="Set amount"
                    type="number"
                    :state="validateState('salary')"
                    invalid-feedback="This is a required field"
                    :class="editable ? 'required' : ''"
                    :editable="editable"
                  />
                </b-col>
                <b-col cols="6">
                  <DatePicker
                    id="effectiveDate"
                    v-model="$v.effectiveDate.$model"
                    name="effectiveDate"
                    label="Effective Date"
                    invalid-feedback="This is a required field"
                    :class="editable ? 'required' : ''"
                    :editable="editable"
                  />
                </b-col>
              </b-row>
            </b-col>
            <b-col cols="6">
              <label class="group-label">CONTACT INFO</label>
              <Input
                id="companyEmail"
                v-model="$v.companyEmail.$model"
                name="companyEmail"
                label="Email"
                type="email"
                :state="validateState('companyEmail')"
                invalid-feedback="This is a required field"
                :class="editable ? 'required' : ''"
                :editable="editable"
              />
              <Input
                id="personalEmail"
                v-model="$v.personalEmail.$model"
                name="personalEmail"
                label="Personal Email"
                type="email"
                :editable="editable"
              />
              <Input
                id="phoneNumber"
                v-model="$v.phoneNumber.$model"
                name="phoneNumber"
                label="Phone Number"
                type="number"
                :editable="editable"
              />
              <DatePicker
                id="birthdate"
                v-model="$v.birthdate.$model"
                name="birthdate"
                label="Birthdate"
                :editable="editable"
              />
            </b-col>

            <b-col cols="12">
              <label class="group-label">BANK INFORMATION</label>
              <Input
                id="bankName"
                v-model="$v.bankName.$model"
                name="bankName"
                label="Bank name"
                type="text"
                :editable="editable"
              />
              <Input
                id="accountNumber"
                v-model="$v.accountNumber.$model"
                name="accountNumber"
                label="Account number"
                type="text"
                :editable="editable"
              />
            </b-col>
            <b-col cols="12">
              <label class="group-label">ADDRESS</label>
              <TextArea
                id="address"
                v-model="address"
                name="address"
                label="Address line"
                :editable="editable"
              />
              <b-row>
                <b-col cols="6">
                  <AddressSelect
                    id="country"
                    v-model="country"
                    label="Country"
                    name="country"
                    :state="validateState('country')"
                    invalid-feedback="This is a required field"
                    :class="editable ? 'required' : ''"
                    :editable="editable"
                    :value="country"
                  />
                </b-col>
                <b-col cols="6">
                  <AddressSelect
                    id="region"
                    v-model="region"
                    label="Region"
                    name="region"
                    :state="validateState('region')"
                    invalid-feedback="This is a required field"
                    :class="editable ? 'required' : ''"
                    :editable="editable"
                    :reg-country="country"
                    :value="region"
                  />
                </b-col>
              </b-row>
              <Input
                id="city"
                v-model="city"
                name="city"
                label="City"
                :class="editable ? 'required' : ''"
                :editable="editable"
                :style="{ width: '40%' }"
              />
            </b-col>
          </b-col>
          <b-col cols="12" :style="{ marginLeft: '10px' }">
            <label class="group-label">ADDRESS</label>
            <b-row>
              <b-col cols="6">
                <AddressSelect
                  id="country"
                  v-model="country"
                  label="Country"
                  name="country"
                  :state="validateState('country')"
                  invalid-feedback="This is a required field"
                  :class="editable ? 'required' : ''"
                  :editable="editable"
                />
              </b-col>
              <b-col cols="6">
                <AddressSelect
                  id="region"
                  v-model="region"
                  label="Region"
                  name="region"
                  :state="validateState('region')"
                  invalid-feedback="This is a required field"
                  :class="editable ? 'required' : ''"
                  :editable="editable"
                  :reg-country="country"
                />
              </b-col>
            </b-row>
            <b-col cols="6" :style="{ marginRight: '15px' }">
              <Input
                id="city"
                v-model="city"
                name="city"
                label="City"
                :class="editable ? 'required' : ''"
                :editable="editable"
              />
            </b-col>
          </b-col>
        </b-col>
        <b-col v-if="!editable">
          <div class="status-box">
            <Select
              id="isActive"
              name="isActive"
              label="Employee Status"
              :state="validateState('isActive')"
              invalid-feedback="This is a required field"
              :class="editable ? 'required' : ''"
              :editable="editable"
              :value="isActive"
            />
            <div
              :class="isActive === 'Active' ? 'status-mark' : 'status-mark-dis'"
            ></div>
          </div>
        </b-col>
        <b-col v-else></b-col>
      </b-row>
    </b-form>
  </b-container>
</template>
<script lang="ts">
import { Vue, Component, Prop, Watch } from 'vue-property-decorator'
import { Validations } from 'vuelidate-property-decorators'
import { validationMixin } from 'vuelidate'
import { required, minValue, email } from 'vuelidate/lib/validators'
import { pathOr } from 'ramda'
import Gravatar from 'vue-gravatar'
import AddressSelect from '@/components/Form/AddressSelect.vue'
// import Button from '@/components/Buttons/Button.vue'
import Input from '@/components/Form/Input.vue'
// import RadioButton from '@/components/Form/RadioButton.vue'
import TextArea from '@/components/Form/TextArea.vue'
import Select from '@/components/Form/Select.vue'
import Radio from '@/components/Form/Radio.vue'
import DatePicker from '@/components/Form/DatePicker.vue'
import TagsInput from '@/components/Form/TagsInput.vue'

import { CreateEmployee, SalaryType, Employee } from '@/types/employee'

@Component({
  components: {
    Input,
    Select,
    DatePicker,
    Radio,
    TagsInput,
    AddressSelect,
    TextArea,
    'v-gravatar': Gravatar
  },
  mixins: [validationMixin]
})
export default class EmployeeForm extends Vue {
  @Prop({ required: false }) private employee?: Employee
  @Prop({ required: true }) private editable!: boolean

  created() {
    this.initializeForm()
  }

  private displayName = ''
  private isActive = ''
  private firstName = ''
  private middleName = ''
  private lastName = ''
  private secondLastName = ''
  private gender = ''
  private companyEmail = ''
  private personalEmail = ''
  private tags: string[] | string = []
  private country = ''
  private region = ''
  private city = ''
  private bankName = ''
  private accountNumber = ''
  private address = ''
  private phoneNumber = ''
  private birthdate = this.$date().format('YYYY-MM-DD')
  private startDate = this.$date().format('YYYY-MM-DD')
  private effectiveDate = this.$date().format('YYYY-MM-DD')
  private salary = 0
  private salaryType = SalaryType.HOURLY
  private salaryTypes = [
    { value: SalaryType.HOURLY, text: 'Hourly' },
    { value: SalaryType.YEARLY, text: 'Yearly' }
  ]

  @Watch('employee')
  initializeForm() {
    if (this.employee) {
      const {
        displayName,
        firstName,
        middleName,
        lastName,
        secondLastName,
        gender,
        companyEmail,
        personalEmail,
        birthdate,
        startDate,
        effectiveDate,
        salary,
        salaryType,
        country,
        city,
        region,
        bankName,
        address,
        accountNumber,
        phoneNumber
      } = this.employee
      this.displayName = displayName
      this.firstName = firstName
      this.middleName = middleName || ''
      this.lastName = lastName
      this.secondLastName = secondLastName || ''
      this.gender = gender
      this.companyEmail = companyEmail
      this.personalEmail = personalEmail
      this.birthdate = this.$date(birthdate).format('YYYY-MM-DD')
      this.startDate = this.$date(startDate).format('YYYY-MM-DD')
      this.effectiveDate = this.$date(effectiveDate).format('YYYY-MM-DD')
      this.salary = salary
      this.salaryType = salaryType
      this.country = country
      this.city = city
      this.region = region
      this.bankName = bankName
      this.address = address
      this.accountNumber = accountNumber
      this.phoneNumber = phoneNumber
    }
    if (!this.editable) {
      this.isActive = this.employee?.isActive! === true ? 'Active' : 'Disabled'
      this.tags =
        this.employee?.tags! !== '[]'
          ? (JSON.parse(this.employee?.tags!) as string[]).join(', ')
          : ' '
    }
  }

  getData(data: CreateEmployee) {
    return data
  }

  @Validations()
  validations = {
    displayName: { required },
    firstName: { required },
    middleName: {},
    lastName: { required },
    secondLastName: {},
    gender: { required },
    companyEmail: { required, email },
    personalEmail: { email },
    birthdate: {},
    startDate: {},
    effectiveDate: {},
    salary: { required, minValue: minValue(0.1) },
    salaryType: {},
    tags: {},
    country: { required },
    city: { required },
    region: { required },
    address: {},
    bankName: {},
    accountNumber: {},
    phoneNumber: {}
  }

  validateState(name: string) {
    const { $dirty, $error } = pathOr(
      { $dirty: undefined, $error: undefined },
      [name],
      this.$v
    )
    return $dirty ? !$error : null
  }

  handleSubmit(): CreateEmployee | null {
    this.$v.$touch()
    if (this.$v.$anyError) {
      return null
    }
    const {
      displayName,
      firstName,
      middleName,
      lastName,
      secondLastName,
      gender,
      companyEmail,
      personalEmail,
      birthdate,
      startDate,
      effectiveDate,
      salary,
      salaryType,
      tags,
      country,
      city,
      region,
      bankName,
      accountNumber,
      address,
      phoneNumber
    } = this
    return this.getData({
      displayName,
      firstName,
      middleName,
      lastName,
      secondLastName,
      gender,
      companyEmail,
      personalEmail,
      birthdate: this.$date(birthdate).format('YYYY-MM-DD[T]HH:mm:ss'),
      effectiveDate: this.$date(effectiveDate).format('YYYY-MM-DD[T]HH:mm:ss'),
      startDate: this.$date(startDate).format('YYYY-MM-DD[T]HH:mm:ss'),
      salary,
      salaryType,
      tags: JSON.stringify(tags),
      country,
      city,
      region,
      bankName,
      accountNumber,
      address,
      phoneNumber
    } as CreateEmployee)
  }
}
</script>

<style>
body {
  background-color: #eef2f3;
  color: #4f4f4f;
}

.group-label {
  font-weight: 700;
  font-size: 15px;
  padding-bottom: 6px;
}
.form-container {
  align-self: center;
  border-radius: 10px;
  background-color: #fff;
  margin: 160px 260px auto 350px !important;
  width: 96%;
  padding-top: 2em;
  padding-bottom: 40px;
  max-width: 1100px !important;
}

.required label:after {
  content: ' *';
  color: red;
}
.avatar-form,
img {
  width: 180px;
  height: 180px;
  border: solid 1px #13bc74;
  padding: 8px;
  display: block;
  border-radius: 500px;
}

.avatar,
img {
  float: none;
  margin: 0;
}

.status-box {
  border-radius: 10px;
  border: solid 1px #f4f4f4;
  padding: 18px 18px 18px 18px;
  margin-top: 20px;
  position: relative;
}

.status-mark {
  width: 22px;
  height: 22px;
  position: absolute;
  top: 20px;
  right: 10px;
  border-radius: 100px;
  background-color: #13bc74;
}

.status-mark-dis {
  width: 22px;
  height: 22px;
  position: absolute;
  top: 20px;
  right: 10px;
  border-radius: 100px;
  background-color: #cacaca;
}

.tags-box {
  border-radius: 10px;
  border: solid 1px #f4f4f4;
  padding: 18px 18px 18px 18px;
  margin-top: 20px;
  position: relative;
}

.tags-container {
  position: relative;
}
</style>
